upstream {{ proj_name }} {
    server 127.0.0.1:{{ gunicorn_port }};
}

server {

    listen 80 default_server;

    {% if tls_enabled %}
    listen 443 ssl;
    {% endif %}
    server_name {{ ansible_hostname }}, {{ inventory_hostname }}, {{  domains|join(", ") }}, {{ ansible_all_ipv4_addresses|join(", ") }};
    client_max_body_size 10M;
    keepalive_timeout    15;

    {% if tls_enabled %}
    ssl_certificate      conf/{{ proj_name }}.crt;
    ssl_certificate_key  conf/{{ proj_name }}.key;
    ssl_session_cache    shared:SSL:10m;
    ssl_session_timeout  10m;
    ssl_ciphers CDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-GCM-SHA384:DHE-RSA-AES128-GCM-SHA256:DHE-DSS-AES128-GCM-SHA256:kEDH+AESGCM:ECDHE-RSA-AES128-SHA256:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA:ECDHE-ECDSA-AES128-SHA:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA:ECDHE-ECDSA-AES256-SHA:DHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA:DHE-DSS-AES128-SHA256:DHE-RSA-AES256-SHA256:DHE-DSS-AES256-SHA:DHE-RSA-AES256-SHA:AES128-GCM-SHA256:AES256-GCM-SHA384:AES128-SHA256:AES256-SHA256:AES128-SHA:AES256-SHA:AES:CAMELLIA:DES-CBC3-SHA:!aNULL:!eNULL:!EXPORT:!DES:!RC4:!MD5:!PSK:!aECDH:!EDH-DSS-DES-CBC3-SHA:!EDH-RSA-DES-CBC3-SHA:!KRB5-DES-CBC3-SHA;
    ssl_prefer_server_ciphers on;
    {% endif %}

    location /dashboard-api {
        proxy_redirect      off;
        proxy_set_header    Host                    $host;
        proxy_set_header    X-Real-IP               $remote_addr;
        proxy_set_header    X-Forwarded-For         $proxy_add_x_forwarded_for;
        proxy_set_header    X-Forwarded-Protocol    $scheme;
        proxy_pass          http://{{ proj_name }};
    }

    access_log  /var/log/nginx/dashboard.access.log;
    error_log  /var/log/nginx/dashboard.error.log;

    location /boxdashboard/static/ {
        alias            {{ www_dashboard_static }};
        access_log      off;
        log_not_found   off;
    }

    location / {
        try_files $uri $uri/ /index.html;
        root            {{ www_root }};
        access_log      on;
        log_not_found   off;

        # turn on gzip compression
        gzip on;
        gzip_disable "msie6";
        gzip_vary on;
        gzip_proxied any;
        gzip_comp_level 5;
        gzip_buffers 16 8k;
        gzip_http_version 1.1;
        gzip_min_length 256;
        gzip_types
            application/javascript
            application/json
            application/ld+json
            application/manifest+json
            application/rss+xml
            font/opentype
            font/truetype
            application/vnd.ms-fontobject
            text/cache-manifest
            text/css
            text/plain
            text/x-component
            text/x-cross-domain-policy;
    }

    location /robots.txt {
        root            {{ proj_path }}/static;
        access_log      off;
        log_not_found   off;
    }

    location /favicon.ico {
        root            {{ proj_path }}/static/img;
        access_log      off;
        log_not_found   off;
    }

    #### Hub nginx conf is copied here

    location /api {
            proxy_pass  http://127.0.0.1:{{ uwsgi_port }}/api;
            include     uwsgi_params; # the uwsgi_params file you installed
     }

    location /media  {
            alias /var/lib/alemhealthhub/media/;
    }

    location /alemhubviewer {
            proxy_pass http://127.0.0.1:8080;
            proxy_set_header Host $host;
            proxy_set_header X-Forwarded-For
            $proxy_add_x_forwarded_for;
    }

    location /grav {
            proxy_pass http://127.0.0.1:{{ gravity_port }};
            proxy_set_header Host $host;
            proxy_set_header X-Forwarded-For
            $proxy_add_x_forwarded_for;
    }
}
